/*
 * Projeto: RMChart
 * Arquivo: TFormTeste.prg
 * Descrio:
 * Autor:
 * Data: 08-20-2016
 */

#include "Xailer.ch"
#include "RMChartX.ch"

CLASS TFormExemploXDLL FROM TForm

   DATA oChart1
   DATA oChart2
   DATA oChart3
   DATA oChart4
   DATA nTicket INIT 1
   DATA cCategoria INIT ""
   DATA cSerie INIT ""

   COMPONENT oScrollBox1
   COMPONENT oScrollBox2
   COMPONENT oScrollBox3
   COMPONENT oScrollBox4

   METHOD CreateForm()
   METHOD FormInitialize( oSender )
   METHOD Graphic1( oCtr, oRm, nId )
   METHOD MakeChart1( oRM, cTitulo, cUnidade, aValor, lSeDespesa )
   METHOD MakeChart2( oRMChart, aFaturamento )
   METHOD FormClose( oSender, @lClose )
   METHOD MakeChartT1( oRMChart )
   METHOD MakeChartT2( oRMChart )
   METHOD MakeChartT3( oRMChart )
   METHOD MakeChartT4( oRMChart )

ENDCLASS

#include "TFormExemploXDLL.xfm"

//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TFormExemploXDLL
LOCAL aDados

::oChart1:= TRMChartXDll():New(::oScrollBox1) //oRM, , Nil)
::Graphic1( ::oChart1 ) //, ::oRm, Nil )
//::MakeChart1( ::oScrollBox2, oRm, 2 )

aDados:= {}
AAdd( aDados, { "201601", 100 } )
AAdd( aDados, { "201602", 200 } )
AAdd( aDados, { "201603", 300 } )
AAdd( aDados, { "201604", 400 } )
AAdd( aDados, { "201605", 300 } )
AAdd( aDados, { "201606", 200 } )
AAdd( aDados, { "201607", 100 } )
//AAdd( aDados, { "META"  , 250 } )
AAdd( aDados, { "MDIA" , 200 } )
AAdd( aDados, { "VELOC.",  60 } )

::oChart2:= TRMChartXDll():New(::oScrollBox2) //oRM, , Nil)
::MakeChart1( ::oChart2, "DESPESA", "R$", aDados , .t. )

::oChart3:= TRMChartXDll():New(::oScrollBox3) //oRM, , Nil)
::oChart3:nAlign := alCLIENT
::MakeChartT3( ::oChart3, aDados)

::oChart4:= TRMChartXDll():New(::oScrollBox4) //oRM, , Nil)
::oChart4:nAlign := alCLIENT
::MakeChartT4( ::oChart4)
RETURN Nil

//------------------------------------------------------------------------------

METHOD Graphic1( oChart ) CLASS TFormExemploXDLL
LOCAL oRMChart

//oRMChart:= TRMChartXailer():New(oCtr) //, oRm, nId)
   WITH OBJECT oChart
      :Reset()
      :RMCBackColor := Default
      :RMCStyle := RMC_CTRLSTYLEFLAT
      :RMCWidth := ::oScrollBox1:nWidth
      :RMCHeight := ::oScrollBox1:nHeight
      :RMCBgImage := ""
      :Font := "Tahoma"
      :RMCToolTipWidth := 0
      :RMCHelpingGridSize := 0
      :RMCHelpingGridColor := Default
      :RMCBitmapColor := Default
      //************** Add Region 1 *****************************
      :AddRegion()
      WITH object :Region(1)
         :Left := 5
         :Top := 5
         :Width := -5
         :Height := -5
         :Footer := ""
         //************** Add grid to region 1 *****************************
         :AddGrid()
         WITH object :Grid
            :BackColor := White
            :AsGradient := .F.
            :BicolorMode := RMC_BICOLOR_NONE
            :Left := 0
            :Top := 0
            :Width := 0
            :Height := 0
         END WITH //Grid
         //************** Add data axis to region 1 *****************************
         :AddDataAxis()

            WITH object :DataAxis(1)
               :Alignment := RMC_DATAAXISLEFT
               :MinValue := 0
               :MaxValue := 0
               :TickCount := 5
               :TextColor := Default
               :LineColor := Default
               :LineStyle := RMC_LINESTYLESOLID
               :DecimalDigits := 2
               :AxisUnit := ""
               :AxisText := ""
            END WITH //DataAxis(1)
            //************** Add label axis to region 1 *****************************
            :AddLabelAxis()
            WITH object :LabelAxis
               :AxisCount := 1
               :TickCount := 5
               :Alignment := RMC_LABELAXISBOTTOM
               :Fontsize := 8
               :TextColor := Default
               :TextAlignment := RMC_TEXTCENTER
               :LineColor := Default
               :LineStyle := RMC_LINESTYLESOLID
               :AxisText := "Vendas (Volumes)"
               :LabelString:= "um*dois*tres*quatro*cinco"
            END WITH //LabelAxis
            //************** Add Series 1 to region 1 *******************************
            :AddLineSeries()
            WITH object :LineSeries(1)
               :SeriesType := RMC_LINE
               :SeriesStyle := RMC_LINE_CABLE
               :LineStyle := RMC_LSTYLE_LINE
               :Lucent := .F.
               :Color := Default
               :SymbolStyle := RMC_SYMBOL_BULLET
               :WhichDataAxis := 1
               :ValueLabelOn := RMC_VLABEL_DEFAULT
               :HatchMode := RMC_HATCHBRUSH_OFF
               //****** Set data values ******
               //:DataString := ::cSerie
               :DataArray := { 10, 11, 12, 13, 14 }
            END WITH //LineSeries(1)
      END WITH //Region(1)
      :DRAW(.T.)
   END WITH //oRMChart

//oRMChart:Reset()
//oRMChart:Draw()


RETURN NIl

//------------------------------------------------------------------------------

METHOD MakeChart1( oChart, cTitulo, cUnidade, aValor, lSeDespesa ) CLASS TFormExemploXDLL

   LOCAL nRetval := 0
   LOCAL cLabel:= ""
   LOCAL cValue:= "", i, nMaior:= 0, nMenor:= 999999999999, nQtde
   LOCAL nSoma:= 0, nMedia:= 0, lMedia:= .f., cMeta:= "", nMeta:= 0, nCont:= 0
   LOCAL cValueAcima:= "", cValueAbaixo:= "", cMedia, aValueAcima, aValueAbaixo
   LOCAL oRMChart

   lSeDespesa:= IIF( lSeDespesa == Nil, .f., lSeDespesa )

   cMedia:= "" //"Mdia: R$ 750.000   Velocidade: 100.7%"
   nQtde:= LEN( aValor )
   FOR i:= 1 TO nQtde
      IF AllTrim(aValor[i,1]) == "META"
         nMeta:= aValor[i,2]
      ELSEIF AllTrim(aValor[i,1]) == "MDIA"
         cMedia+= "Mdia: "
         IF cUnidade == "R$"
            cMedia+= cUnidade+" "
         ENDIF
         cMedia+= ALLTRIM(TRAN(aValor[i,2], "@E 999,999,999.99"))
         IF !(cUnidade == "R$")
            cMedia+= cUnidade
         ENDIF
      ELSEIF AllTrim(aValor[i,1]) == "VELOC."
         IF !EMPTY( cMedia )
            cMedia+= SPAC(3)
         ENDIF
         cMedia+= "Velocidade: "+ALLTRIM(TRAN(aValor[i,2], "@E 999,999,999.9"))+"%"
      ELSEIF nCont < 12
         nCont++
         nSoma+= aValor[i,2]
         IF aValor[i,2] > nMaior
            nMaior:= aValor[i,2]
         ENDIF
         IF aValor[i,2] < nMenor
            nMenor:= aValor[i,2]
         ENDIF
      ENDIF
   NEXT
   //nMaior:= nMaior*1.2
   //nMenor:= nMenor*0.8
   IF Empty(nMeta)
      IF nCont > 1
         nMeta:= nSoma / nCont
         lMedia:= .t.
      ENDIF
   ENDIF
   aValueAcima:= {}
   aValueAbaixo:= {}
   nCont:= 0
   FOR i:= 1 TO nQtde
      IF AllTrim(aValor[i,1]) == "META"
      ELSEIF AllTrim(aValor[i,1]) == "MDIA"
      ELSEIF AllTrim(aValor[i,1]) == "VELOC."
      ELSEIF nCont < 12
         nCont++
         IF nCont > 1
            cLabel+= "*"
            cValueAcima+= "*"
            cValueAbaixo+= "*"
         ENDIF
         cLabel+= RIGHT(aValor[i,1],2)+"/"+LEFT(aValor[i,1],4)
         IF aValor[i,2] >= nMeta
            cValueAcima+= ALLTRIM(STR(aValor[i,2],16,2))
            cValueAbaixo+= "0"
            AAdd( aValueAcima, aValor[i,2] )
            AAdd( aValueAbaixo, 0 )
         ELSE
            cValueAcima+= "0"
            cValueAbaixo+= ALLTRIM(STR(aValor[i,2],16,2))
            AAdd( aValueAbaixo, aValor[i,2] )
            AAdd( aValueAcima, 0 )
         ENDIF
      ENDIF
   NEXT

   nMaior:= nMeta * 2
   nMenor:= 0
   cMeta:= cUnidade+" "+AllTrim(TRAN(nMeta,"@E 999,999,999,999.99"))+IIF( lMedia, " MED","")

   WITH OBJECT oChart
      :Reset()
      :RMCBackColor := White
      :RMCStyle := RMC_CTRLSTYLE3DLIGHT
      :RMCWidth := 410
      :RMCHeight := 330
      :RMCBgImage := ""
      :Font := "Arial"
      :RMCToolTipWidth := 200
      :RMCHelpingGridSize := 0
      :RMCHelpingGridColor := Default
      :RMCBitmapColor := Default
      //************** Add Region 1 *****************************
      :AddRegion()
      WITH object :Region(1)
         :Left := 5
         :Top := 5
         :Width := -5
         :Height := -5
         :Footer := ""
         //************** Add caption to region 1 *******************
         :AddCaption()
         WITH object :Caption
            :Titel := cTitulo
            :BackColor := Default
            :TextColor := Default
            :FontSize := 15
            :Bold := .T.
         END WITH //Caption
         //************** Add grid to region 1 *****************************
         :AddGrid()
         WITH object :Grid
            :BackColor := WhiteSmoke
            :AsGradient := .T.
            :BicolorMode := RMC_BICOLOR_DATAAXIS
            :Left := 42
            :Top := 28
            :Width := 257
            :Height := 230
         END WITH //Grid
         //************** Add data axis to region 1 *****************************
         :AddDataAxis()
         WITH object :DataAxis(1)
            :Alignment := RMC_DATAAXISBOTTOM
            :MinValue := nMenor
            :MaxValue := nMaior
            :TickCount := 3
            :Fontsize := 8
            :TextColor := Default
            :LineColor := Default
            :LineStyle := RMC_LINESTYLESOLID
            :DecimalDigits := IIF( cUnidade == "%", 2, 0 )
            :AxisUnit := cUnidade
            :AxisText := ""
            :LabelTextAlignment := RMC_TEXTCENTER
            :LabelString := "Meta*"+cMeta+"*"
         END WITH //DataAxis(1)
         //************** Add label axis to region 1 *****************************
         :AddLabelAxis()
         WITH object :LabelAxis
            :AxisCount := 1
            :TickCount := 12
            :Alignment := RMC_LABELAXISLEFT
            :Fontsize := 8
            :TextColor := Default
            :TextAlignment := RMC_TEXTCENTER
            :LineColor := Transparent
            :LineStyle := RMC_LINESTYLENONE
            :AxisText := ""
            :LabelString := cLabel //"01/2014*02/2014*03/2014*04/2014*05/2014*06/2014*07/2014*08/2014*09/2014*10/2014*" + ;
                            //"11/2014*12/2014"
         END WITH //LabelAxis
         //************** Add Series 1 to region 1 *******************************
         :AddBarSeries()
         WITH object :BarSeries(1)
            :SeriesType := RMC_BARSINGLE
            :SeriesStyle := RMC_BAR_FLAT
            :Lucent := .T.
            :Color := SkyBlue
            :Horizontal := .T.
            :WhichDataAxis := 1
            :ValueLabelOn := RMC_VLABEL_DEFAULT_NOZERO
            :PointsPerColumn := 1
            :HatchMode := RMC_HATCHBRUSH_OFF
            //****** Set data values ******
            //:DataString := IIF( lSeDespesa, cValueAbaixo, cValueAcima ) //"0*5800000.5*6000000*8500000*7500000*6800000*7100000*8000000*8600000*8400000*6900" + ;
            :DataArray:= IIF( lSeDespesa, aValueAbaixo, aValueAcima )
                           //"000*6100000"
         END WITH //BarSeries(1)
         //************** Add Series 2 to region 1 *******************************
         :AddBarSeries()
         WITH object :BarSeries(2)
            :SeriesType := RMC_BARSINGLE
            :SeriesStyle := RMC_BAR_FLAT
            :Lucent := .T.
            :Color := Red
            :Horizontal := .T.
            :WhichDataAxis := 1
            :ValueLabelOn := RMC_VLABEL_DEFAULT_NOZERO
            :PointsPerColumn := 1
            :HatchMode := RMC_HATCHBRUSH_OFF
            //****** Set data values ******
            //:DataString := IIF( lSeDespesa, cValueAcima, cValueAbaixo ) //"5000000*0*0*0*0*0*0*0*0*0*0*0"
            :DataArray:= IIF( lSeDespesa, aValueAcima, aValueAbaixo )
         END WITH //BarSeries(2)
         /*
         //************** Add Series 1 to region 1 *******************************
         :AddBarSeries()
         WITH object :BarSeries(1)
            :SeriesType := RMC_BARSINGLE
            :SeriesStyle := RMC_BAR_FLAT_GRADIENT1
            :Lucent := .T.
            :Color := SkyBlue
            :Horizontal := .T.
            :WhichDataAxis := 1
            :ValueLabelOn := RMC_VLABEL_DEFAULT
            :PointsPerColumn := 1
            :HatchMode := RMC_HATCHBRUSH_OFF
            //****** Set data values ******
            :DataString := cValue //"5000000*5800000.5*6000000*8500000*7500000*6800000*7100000*8000000*8600000*840000" + ;
                           //"0*6900000*6100000"
         END WITH //BarSeries(1)
         */
      END WITH //Region(1)
      //************** Add CustomObjects *******************************

      :AddCustomObjectText()
      WITH object :CustomObjectText(1)
         :Text := cMedia //"Mdia: R$ 750.000   Velocidade: 100.7%"
         :Left := 40
         :Top := 279
         :Width := 271
         :Height := 18
         :Style := RMC_BOX_GRADIENTV
         :BGColor := AliceBlue
         :LineColor := Default
         :Transparency := 0
         :LineAlignment := RMC_LINE_HORIZONTAL
         :TextColor := Default
         :TextAlignment := RMC_TEXTCENTER
         :FontBold := .F.
         :FontSize := 0
      END WITH //CustomObjectText # 1

      nRetval := :DRAW(.T.)
   END WITH //oRMChart

RETURN nRetval

//------------------------------------------------------------------------------

METHOD MakeChart2( oRMChart, aFaturamento )  CLASS TFormExemploXDLL

   LOCAL nRetval := 0
   LOCAL cLabel:= ""
   LOCAL cValue:= "", i, nMaior:= 0, nMenor:= 999999999999, nQtde
   LOCAL aDados:= {}

   nQtde:= LEN( aFaturamento )
   FOR i:= 1 TO nQtde
      cLabel+= RIGHT(aFaturamento[i,1],2)+"/"+LEFT(aFaturamento[i,1],4)
      cValue+= ALLTRIM(STR(aFaturamento[i,2],16))
      IF aFaturamento[i,2] > nMaior
         nMaior:= aFaturamento[i,2]
      ENDIF
      IF aFaturamento[i,2] < nMenor
         nMenor:= aFaturamento[i,2]
      ENDIF
      IF i < nQtde
         cLabel+= "*"
         cValue+= "*"
      ENDIF
      AAdd( aDados, aFaturamento[i,2] )
   NEXT
   nMaior:= nMaior*1.2
   nMenor:= nMenor*0.8

   WITH OBJECT oRMChart
      //:Reset()
      //:SetProperties (600, 250, White, RMC_CTRLSTYLE3DLIGHT,"", "Microsoft Sans Serif", 0, 0, Default, Default)
      :Reset()
      :RMCBackColor := White
      :RMCStyle := RMC_CTRLSTYLE3DLIGHT
      :RMCWidth := 400
      :RMCHeight := 330
      :RMCBgImage := ""
      :Font := "Arial"
      :RMCToolTipWidth := 200
      :RMCHelpingGridSize := 0
      :RMCHelpingGridColor := Default
      :RMCBitmapColor := Default
      //************** Add Region 1 *****************************
      :AddRegion()
      WITH object :Region(1)
         //:SetProperties (5, 5, -5, -5, "")
         :Left := 5
         :Top := 5
         :Width := -5
         :Height := -5
         :Footer := ""
         //************** Add caption to region 1 *******************
         :AddCaption()
         WITH object :Caption
            //:SetProperties ("Valor Atendido (R$)", White, Black, 14, .T.)
            :Titel := "Valor Atendido (R$)"
            :BackColor := White
            :TextColor := Black
            :FontSize := 14
            :Bold := .T.
         END WITH //Caption
         //************** Add grid to region 1 *****************************
         :AddGrid()
         WITH object :Grid
            :SetProperties (White, .F., 0, 0, 0, 0, RMC_BICOLOR_NONE)
            :BackColor := White
            :AsGradient := .f.
            :BicolorMode := RMC_BICOLOR_NONE
            :Left := 0
            :Top := 0
            :Width := 0
            :Height := 0
         END WITH //Grid
         //************** Add data axis to region 1 *****************************
         :AddDataAxis()
         WITH object :DataAxis(1)
            //:SetProperties (RMC_DATAAXISLEFT, nMenor, nMaior, 11, 8, Default, White, RMC_LINESTYLENONE, 0, "", "", "", RMC_TEXTRIGHT)
            :Alignment := RMC_DATAAXISLEFT
            :MinValue := nMenor
            :MaxValue := nMaior
            :TickCount := 11
            :Fontsize := 8
            :TextColor := Default
            :LineColor := White
            :LineStyle := RMC_LINESTYLENONE
            :DecimalDigits := 0
            :AxisUnit := ""
            :AxisText := ""
            :LabelTextAlignment := RMC_TEXTRIGHT
            :LabelString := ""
         END WITH //DataAxis(1)
         //************** Add label axis to region 1 *****************************
         :AddLabelAxis()
         WITH object :LabelAxis
            //:SetProperties (1, nQtde, RMC_LABELAXISBOTTOM, 8, Default, RMC_TEXTCENTER, Default, RMC_LINESTYLENONE, "")
            //:LabelString := cLabel //"2011*2012*2013*2014*2015"
            :AxisCount := 1
            :TickCount := nQtde
            :Alignment := RMC_LABELAXISBOTTOM
            :Fontsize := 8
            :TextColor := Default
            :TextAlignment := RMC_TEXTCENTER
            :LineColor := Transparent
            :LineStyle := RMC_LINESTYLENONE
            :AxisText := ""
            :LabelString := cLabel //"01/2014*02/2014*03/2014*04/2014*05/2014*06/2014*07/2014*08/2014*09/2014*10/2014*" + ;
         END WITH //LabelAxis
         //************** Add legend to region 1 *******************************
         //:AddLegend()
         //WITH object :Legend
         //   :SetProperties (RMC_LEGEND_CUSTOM_BOTTOM, Default, RMC_LEGENDNORECT, Default, 8, .F.)
         //   :LegendString := ""
         //END WITH //Legend
         //************** Add Series 1 to region 1 *******************************
         :AddBarSeries()
         WITH object :BarSeries(1)
            //:SetProperties (RMC_BARSINGLE, RMC_BAR_3D_GRADIENT, .F., Default, .F., 1, RMC_VLABEL_DEFAULT, 1, RMC_HATCHBRUSH_OFF)
            //****** Set data values ******
            //:DataString := cValue //"9000000*10000000*12000000*15000000*14000000"
            :SeriesType := RMC_BARSINGLE
            :SeriesStyle := RMC_BAR_3D_GRADIENT
            :Lucent := .F.
            :Color := Default
            :Horizontal := .F.
            :WhichDataAxis := 1
            :ValueLabelOn := RMC_VLABEL_DEFAULT
            :PointsPerColumn := 1
            :HatchMode := RMC_HATCHBRUSH_OFF
            //****** Set data values ******
            //:DataString := IIF( lSeDespesa, cValueAbaixo, cValueAcima ) //"0*5800000.5*6000000*8500000*7500000*6800000*7100000*8000000*8600000*8400000*6900" + ;
            :DataArray:= aDados
         END WITH //BarSeries(1)
      END WITH //Region(1)
      nRetval := :DRAW(.T.)
   END WITH //oRMChart

RETURN nRetval

//------------------------------------------------------------------------------

METHOD FormClose( oSender, lClose ) CLASS TFormExemploXDLL
::oChart1:= Nil
::oChart2:= Nil
::oChart3:= Nil
::oChart4:= Nil
RETURN Nil

//------------------------------------------------------------------------------

METHOD MakeChartT1( oRMChart ) CLASS TFormExemploXDLL

   LOCAL nRetval := 0

   WITH OBJECT oRMChart
      :Reset()
      :RMCBackColor := White
      :RMCStyle := RMC_CTRLSTYLE3DLIGHT
      :RMCWidth := 600
      :RMCHeight := 250
      :RMCBgImage := ""
      :Font := "Microsoft Sans Serif"
      :RMCToolTipWidth := 0
      :RMCHelpingGridSize := 0
      :RMCHelpingGridColor := Default
      :RMCBitmapColor := Default
      //************** Add Region 1 *****************************
      :AddRegion()
      WITH object :Region(1)
         :Left := 5
         :Top := 5
         :Width := -5
         :Height := -5
         :Footer := ""
         //************** Add caption to region 1 *******************
         :AddCaption()
         WITH object :Caption
            :Titel := "Faturamento (R$)"
            :BackColor := White
            :TextColor := Black
            :FontSize := 14
            :Bold := .T.
         END WITH //Caption
         //************** Add grid to region 1 *****************************
         :AddGrid()
         WITH object :Grid
            :BackColor := White
            :AsGradient := .F.
            :BicolorMode := RMC_BICOLOR_NONE
            :Left := 0
            :Top := 0
            :Width := 0
            :Height := 0
         END WITH //Grid
         //************** Add data axis to region 1 *****************************
         :AddDataAxis()
         WITH object :DataAxis(1)
            :Alignment := RMC_DATAAXISLEFT
            :MinValue := 0
            :MaxValue := 18000000
            :TickCount := 11
            :Fontsize := 8
            :TextColor := Default
            :LineColor := White
            :LineStyle := RMC_LINESTYLENONE
            :DecimalDigits := 0
            :AxisUnit := ""
            :AxisText := ""
         END WITH //DataAxis(1)
         //************** Add label axis to region 1 *****************************
         :AddLabelAxis()
         WITH object :LabelAxis
            :AxisCount := 1
            :TickCount := 5
            :Alignment := RMC_LABELAXISBOTTOM
            :Fontsize := 8
            :TextColor := Default
            :TextAlignment := RMC_TEXTCENTER
            :LineColor := Default
            :LineStyle := RMC_LINESTYLENONE
            :AxisText := ""
            :LabelString := "2011*2012*2013*2014*2015"
         END WITH //LabelAxis
         //************** Add legend to region 1 *******************************
         :AddLegend()
         WITH object :Legend
            :Alignment := RMC_LEGEND_CUSTOM_BOTTOM
            :BackColor := Default
            :Style := RMC_LEGENDNORECT
            :TextColor := Default
            :Fontsize := 8
            :Bold := .F.
            :LegendString := ""
         END WITH //Legend
         //************** Add Series 1 to region 1 *******************************
         :AddBarSeries()
         WITH object :BarSeries(1)
            :SeriesType := RMC_BARSINGLE
            :SeriesStyle := RMC_BAR_3D_GRADIENT
            :Lucent := .F.
            :Color := Default
            :Horizontal := .F.
            :WhichDataAxis := 1
            :ValueLabelOn := RMC_VLABEL_DEFAULT
            :PointsPerColumn := 1
            :HatchMode := RMC_HATCHBRUSH_OFF
            //****** Set data values ******
            :DataString := "9000000*10000000*12000000*15000000*14000000"
         END WITH //BarSeries(1)
      END WITH //Region(1)
      nRetval := :DRAW(.T.)
   END WITH //oRMChart

RETURN nRetval

//------------------------------------------------------------------------------

METHOD MakeChartT2( oRMChart ) CLASS TFormExemploXDLL

   LOCAL nRetval := 0

   WITH OBJECT oRMChart
      :Reset()
      :SetProperties (600, 250, White, RMC_CTRLSTYLE3DLIGHT,"", "Microsoft Sans Serif", 0, 0, Default, Default)
      //************** Add Region 1 *****************************
      :AddRegion()
      WITH object :Region(1)
         :SetProperties (5, 5, -5, -5, "")
         //************** Add caption to region 1 *******************
         :AddCaption()
         WITH object :Caption
            :SetProperties ("Faturamento (R$)", White, Black, 14, .T.)
         END WITH //Caption
         //************** Add grid to region 1 *****************************
         :AddGrid()
         WITH object :Grid
            :SetProperties (White, .F., 0, 0, 0, 0, RMC_BICOLOR_NONE)
         END WITH //Grid
         //************** Add data axis to region 1 *****************************
         :AddDataAxis()

         WITH object :DataAxis(1)
            :SetProperties (RMC_DATAAXISLEFT, 0, 18000000, 11, 8, Default, White, RMC_LINESTYLENONE, 0, "", "" ) //, "", RMC_TEXTRIGHT)
         END WITH //DataAxis(1)

         /*
         WITH object :DataAxis(1)
            :Alignment := RMC_DATAAXISLEFT
            :MinValue := 0
            :MaxValue := 18000000
            :TickCount := 11
            :Fontsize := 8
            :TextColor := Default
            :LineColor := White
            :LineStyle := RMC_LINESTYLENONE
            :DecimalDigits := 0
            :AxisUnit := ""
            :AxisText := ""
         END WITH //DataAxis(1)
         */
         //************** Add label axis to region 1 *****************************
         :AddLabelAxis()
         WITH object :LabelAxis
            :SetProperties (1, 5, RMC_LABELAXISBOTTOM, 8, Default, RMC_TEXTCENTER, Default, RMC_LINESTYLENONE, "")
            :LabelString := "2011*2012*2013*2014*2015"
         END WITH //LabelAxis
         //************** Add legend to region 1 *******************************
         :AddLegend()
         WITH object :Legend
            :SetProperties (RMC_LEGEND_CUSTOM_BOTTOM, Default, RMC_LEGENDNORECT, Default, 8, .F.)
            :LegendString := ""
         END WITH //Legend
         //************** Add Series 1 to region 1 *******************************
         :AddBarSeries()
         WITH object :BarSeries(1)
            :SetProperties (RMC_BARSINGLE, RMC_BAR_3D_GRADIENT, .F., Default, .F., 1, RMC_VLABEL_DEFAULT, 1, RMC_HATCHBRUSH_OFF)
            //****** Set data values ******
            :DataString := "9000000*10000000*12000000*15000000*14000000"
         END WITH //BarSeries(1)
      END WITH //Region(1)
      nRetval := :DRAW(.T.)
   END WITH //oRMChart

RETURN nRetval

//------------------------------------------------------------------------------

METHOD MakeChartT3( oRMChart )

   LOCAL nRetval := 0

   WITH OBJECT oRMChart
      :Reset()
      :RMCBackColor := White
      :RMCStyle := RMC_CTRLSTYLE3DLIGHT
      :RMCWidth := 600
      :RMCHeight := 250
      :RMCBgImage := ""
      :Font := "Microsoft Sans Serif"
      :RMCToolTipWidth := 0
      :RMCHelpingGridSize := 0
      :RMCHelpingGridColor := Default
      :RMCBitmapColor := Default
      //************** Add Region 1 *****************************
      :AddRegion()
      WITH object :Region(1)
         :Left := 5
         :Top := 5
         :Width := -5
         :Height := -5
         :Footer := ""
         //************** Add caption to region 1 *******************
         :AddCaption()
         WITH object :Caption
            :Titel := "Resultado Lquido x Bruto (%)"
            :BackColor := White
            :TextColor := Black
            :FontSize := 14
            :Bold := .T.
         END WITH //Caption
         //************** Add grid to region 1 *****************************
         :AddGrid()
         WITH object :Grid
            :BackColor := White
            :AsGradient := .F.
            :BicolorMode := RMC_BICOLOR_NONE
            :Left := 0
            :Top := 0
            :Width := 0
            :Height := 0
         END WITH //Grid
         //************** Add data axis to region 1 *****************************
         :AddDataAxis()
         WITH object :DataAxis(1)
            :Alignment := RMC_DATAAXISLEFT
            :MinValue := 0
            :MaxValue := 30
            :TickCount := 7
            :Fontsize := 8
            :TextColor := Default
            :LineColor := Default
            :LineStyle := RMC_LINESTYLEDOT
            :DecimalDigits := 0
            :AxisUnit := ""
            :AxisText := ""
         END WITH //DataAxis(1)
         //************** Add label axis to region 1 *****************************
         :AddLabelAxis()
         WITH object :LabelAxis
            :AxisCount := 1
            :TickCount := 5
            :Alignment := RMC_LABELAXISBOTTOM
            :Fontsize := 8
            :TextColor := Default
            :TextAlignment := RMC_TEXTCENTER
            :LineColor := Default
            :LineStyle := RMC_LINESTYLENONE
            :AxisText := ""
            :LabelString := "2011*2012*2013*2014*2015"
         END WITH //LabelAxis
         //************** Add legend to region 1 *******************************
         :AddLegend()
         WITH object :Legend
            :Alignment := RMC_LEGEND_UR
            :BackColor := Default
            :Style := RMC_LEGENDNORECT
            :TextColor := Default
            :Fontsize := 8
            :Bold := .F.
            :LegendString := "Bruto*Lq."
         END WITH //Legend
         //************** Add Series 1 to region 1 *******************************
         :AddBarSeries()
         WITH object :BarSeries(1)
            :SeriesType := RMC_BARSINGLE
            :SeriesStyle := RMC_BAR_HOVER
            :Lucent := .F.
            :Color := BabyBlue
            :Horizontal := .F.
            :WhichDataAxis := 1
            :ValueLabelOn := RMC_VLABEL_DEFAULT
            :PointsPerColumn := 1
            :HatchMode := RMC_HATCHBRUSH_OFF
            //****** Set data values ******
            :DataString := "9*10*12*15*14"
         END WITH //BarSeries(1)
         //************** Add Series 2 to region 1 *******************************
         :AddLineSeries()
         WITH object :LineSeries(1)
            :SeriesType := RMC_LINE
            :SeriesStyle := RMC_LINE_CABLE
            :LineStyle := RMC_LSTYLE_LINE
            :Lucent := .F.
            :Color := Orange
            :SymbolStyle := RMC_SYMBOL_BULLET
            :WhichDataAxis := 1
            :ValueLabelOn := RMC_VLABEL_DEFAULT
            :HatchMode := RMC_HATCHBRUSH_OFF
            //****** Set data values ******
            :DataString := "28*20*25*23*24"
         END WITH //LineSeries(1)
      END WITH //Region(1)
      nRetval := :DRAW(.T.)
   END WITH //oRMChart

RETURN nRetval

//------------------------------------------------------------------------------

METHOD MakeChartT4( oRMChart )

   LOCAL nRetval := 0

   WITH OBJECT oRMChart
      :Reset()
      :RMCBackColor := White
      :RMCStyle := RMC_CTRLSTYLE3DLIGHT
      :RMCWidth := 400
      :RMCHeight := 300
      :RMCBgImage := ""
      :Font := "Calibri"
      :RMCToolTipWidth := 0
      :RMCHelpingGridSize := 0
      :RMCHelpingGridColor := Default
      :RMCBitmapColor := Default
      //************** Add Region 1 *****************************
      :AddRegion()
      WITH object :Region(1)
         :Left := 5
         :Top := 5
         :Width := -5
         :Height := -5
         :Footer := ""
         //************** Add caption to region 1 *******************
         :AddCaption()
         WITH object :Caption
            :Titel := "COMISSO"
            :BackColor := Default
            :TextColor := Default
            :FontSize := 15
            :Bold := .T.
         END WITH //Caption
         //************** Add legend to region 1 *******************************
         :AddLegend()
         WITH object :Legend
            :Alignment := RMC_LEGEND_ONVLABELS
            :TextColor := Default
            :Fontsize := 8
            :Bold := .F.
            :LegendString := "Representante*Promotor*Bico*Transporte"
         END WITH //Legend
         //************** Add Series 1 to region 1 *******************************
         :AddGridlessSeries()
         WITH object :GridLessSeries
            :SeriesStyle := RMC_PIE_3D
            :Alignment := RMC_FULL
            :Explodemode := RMC_EXPLODE_BIGGEST
            :Lucent := .F.
            :ValueLabelOn := RMC_VLABEL_DEFAULT
            :HatchMode := RMC_HATCHBRUSH_OFF
            :StartAngle := 0
            //****** Set color values ******
            :SetColorValue( 1, Default)
            :SetColorValue( 2, Default)
            :SetColorValue( 3, Default)
            :SetColorValue( 4, Default)
            //****** Set data values ******
            :DataString := "1000000*800000*850000*600000"
         END WITH //GridLessSeries
      END WITH //Region(1)
      nRetval := :DRAW(.T.)
   END WITH //oRMChart

RETURN nRetval

//------------------------------------------------------------------------------
